!ABCIncludeFile
! RDC Class Wrapper
 include('rdc.equ')

! abstract class for any collection object

RDCCollection         Class,type,module('RDC.CLW'),LINK('RDC.CLW',_RDCLinkMode_),DLL(_RDCDLLMode_)
OleControl              ushort
Window                  &Window
Parent                  &cstring              ! parent object
Item                    cstring(20)           ! currentobject
CollectionName          cstring(50)           ! name of collection
Command                 cstring(200)
Init                    procedure(*cstring ParentObject,string CollectionName,ushort OleControl,Window Window),virtual
Delete                  procedure(long Index) ! delete
GetItem                 procedure(long Index),virtual! get objetc by number
GetItemByName           procedure(string ItemName),virtual
Count                   procedure,long ! get amount of collection items
Kill                    procedure,virtual
 end

! Abstract class for the Item inside collection

RDCCollectionItem    Class,type,module('RDC.CLW'),DLL(_RDCDLLMode_)
OleControl              ushort    ! ole control
Window                  &Window   ! ole window
Item                    &cstring  ! reference to the current item
Command                 cstring(200)
Init                    procedure(*cstring Item,ushort OleControl,Window Window),virtual
Kill                    procedure,virtual
 end

DataBaseFieldDefinition class(RDCCollectionItem),type,module('RDC.CLW'),DLL(_RDCDLLMode_)
DataBaseFieldName       string(100)
Kind                    byte
 end


DataBaseFieldDefinitions  class(RDCCollection),type,module('RDC.CLW'),LINK('RDC.CLW',_RDCLinkMode_),DLL(_RDCDLLMode_)
Init                    procedure(*cstring ParentObject,string CollectionName,ushort OleControl,Window Window),virtual
Kill                    procedure,virtual
DataBaseFieldDefinition &DataBaseFieldDefinition
GetItemByName           procedure(string FieldName),virtual
 end

DatabaseTable class(RDCCollectionItem),type,module('RDC.CLW'),DLL(_RDCDLLMode_)
Fields                  &DataBaseFieldDefinitions
DatabaseType            short  !CrDatabasetype
ConnectBufferString     cstring(255) ! Gets the table connect buffer string  Read only
DllName                 cstring(100) ! Gets the table driver DLL name. Read only
Name                    cstring(255)
Location                cstring(255)
Sublocation             cstring(255)
LogOnDatabaseName       cstring(255)
LogOnServerName         cstring(255)
LogOnUserID             cstring(255)
GetProperties           procedure,virtual
UpdateProperties        procedure
SetTableLocation        procedure(string pLocation,string pSubLocation,string pConnectBufferString)
SetLogOnInfo            procedure(string pServerName,<string pDatabaseName>,<string pUserID>,<string pPassword>)
TestConnectivity        procedure,byte
GetConnectionProperties procedure(),*ConnectionProperties
 end


DatabaseTables       class(RDCCollection),type,module('RDC.CLW'),LINK('RDC.CLW',_RDCLinkMode_),DLL(_RDCDLLMode_)
DataBaseTable           &DataBaseTable
Getitem                 procedure(long Index),virtual
AddTable                procedure(String pLocation,<string pSubLocation>,<string pConnectInfo>,<short tableType>, <string pDllName>,<string pServerName>,<string pServerType>,<string pDatabaseName>, <string pUserID>,<string pPassword>)
Init                    procedure(*cstring ParentObject,string CollectionName,ushort OleControl,Window Window),virtual
Kill                    procedure,virtual
 end

ConnectionProperty class(RDCCollectionItem),type,module('RDC.CLW'),DLL(_RDCDLLMode_)
Description     cstring(100)
LocalizedName   cstring(100)
Name            cstring(100)
Value           cstring(100)
GetProperties           procedure,virtual
UpdateProperties        procedure

 end

SubReports              class(RDCCollection),type,module('RDC.CLW'),LINK('RDC.CLW',_RDCLinkMode_),DLL(_RDCDLLMode_)
SubReportname           cstring(255)
GetItem                 procedure(long Index),virtual
GetitemByName           procedure(string ItemName),virtual
Count                   procedure(),long
                        end

ConnectionProperties class(RDCCollection),type,module('RDC.CLW'),LINK('RDC.CLW',_RDCLinkMode_),DLL(_RDCDLLMode_)
ConnectionProperty      &ConnectionProperty
GetItem                 procedure(long Index),virtual
GetitemByName           procedure(string ItemName),virtual
Init                    procedure(*cstring ParentObject,string CollectionName,ushort OleControl,Window Window),virtual
Kill                    procedure,virtual
 end

FormulaFieldDefinitions class(RDCCollection),type,module('RDC.CLW'),LINK('RDC.CLW',_RDCLinkMode_),DLL(_RDCDLLMode_)
FormulaFieldDefinition  &FormulaFieldDefinition
GetItem                 procedure(long Index),virtual
GetItemByName           procedure(string FormulaName),virtual
AddFormula              procedure(*cstring FormulaName,*cstring FormulaText)
Init                    procedure(*cstring ParentObject,string CollectionName,ushort OleControl,Window Window),virtual
Kill                    procedure,virtual
 end

FormulaFieldDefinition class(RDCCollectionItem),type,module('RDC.ClW'),DLL(_RDCDLLMode_)
FormulaFieldName        cstring(100)
Name                    cstring(100)
NumberOfBytes           short
Text                    cstring(4000)
Check                   procedure(*byte pBool,*cstring ppErrorString)
GetProperties           procedure
UpdateProperties        procedure
 end

GroupNameFieldDefinitions class(RDCCollection),type,module('RDC.CLW'),LINK('RDC.CLW',_RDCLinkMode_),DLL(_RDCDLLMode_)
 end

RunningTotalFieldDefinitions class(RDCCollection),type,module('RDC.CLW'),LINK('RDC.CLW',_RDCLinkMode_),DLL(_RDCDLLMode_)
 end

SortFields class(RDCCollection),type,module('RDC.CLW'),LINK('RDC.CLW',_RDCLinkMode_),DLL(_RDCDLLMode_)
 end

SQLExpressionFieldDefinitions class(RDCCollection),type,module('RDC.CLW'),LINK('RDC.CLW',_RDCLinkMode_),DLL(_RDCDLLMode_)
 end

SummaryFieldDefinitions class(RDCCollection),type,module('RDC.CLW'),LINK('RDC.CLW',_RDCLinkMode_),DLL(_RDCDLLMode_)
 end

ParameterFieldDefinitions class(RDCCollection),type,module('RDC.CLW'),LINK('RDC.CLW',_RDCLinkMode_),DLL(_RDCDLLMode_)
ParameterFieldDefinition &ParameterFieldDefinition
Init                    procedure(*cstring ParentObject,string CollectionName,ushort OleControl,Window Window),virtual
Kill                    procedure,virtual
Getitem                 procedure(long Index),virtual
GetItemByName           procedure(string ParameterName),virtual
GetItemByName           procedure(string ParameterName,string SubReportName),virtual
AddParameter            procedure(String ParameterName, byte  ValueType ) ! ValueType As CRFieldValueType
 end

ParameterFieldDefinition class(RDCCollectionItem),type,module('RDC.CLW'),DLL(_RDCDLLMode_)
DisallowEditing         byte ! Gets or sets the disallowing editing option.
ParameterFieldName      cstring(100) ! read only
ParameterType           byte ! CRParameterFieldType. Gets parameter type. Read only
Prompt                  cstring(100) ! Gets or sets the parameter field prompting string.
Value                   any ! Gets the current value of the field. Read only (only when formatting is active)
ValueType               byte ! CRFieldValueType. Gets which type of value is found in the field. read only
IsCurrentValueSet       byte ! Gets whether the current value has been set. Read only
IsDefaultValueSet       byte ! Gets whether the default value has been set. Read only
NumberOfCurrentValues   byte ! Gets the total number of current values. Read only
NumberOfDefaultValues   byte ! Gets the total number of current values. Read only
EnableMultipleValues    byte ! Gets or sets the allow multiple values option. Read/Write
AddCurrentValue         procedure(any CurrentValue,<any CurrentValueEx>)
AddDefaultValue         procedure(any CurrentValue,<any CurrentValueEx>)
DeleteNthDefaultValue   procedure(long index)
GetNthCurrentValue      procedure(long index),any
GetNthDefaultValue      procedure(long index),any
!SetNthDefaultValue      procedure(long index,any nthDefaultValue,<any nthDefaultValueEx>)
ClearCurrentValueAndRange procedure
GetProperties             procedure
UpdateProperties          procedure

 end

RDCApplication Class,TYPE,MODULE('RDC.CLW'),LINK('RDC.CLW',_RDCLinkMode_),DLL(_RDCDLLMode_)
AppOle                  ushort
Window                  &Window
ParentDesign            ushort
AppObject               cstring(20)
ProcessSQLQueryProperty byte(false)
Init                    procedure(short ParentDesignControl=0,<Window window>,<string CreateString>),byte,proc
Kill                    procedure(),proc
LogOnServer             procedure(string pDllName,string pServerName,<string pDatabaseName>,<string pUserID>,<string pPassword>)
LogOnServerEx           procedure(string pDllName,string pServerName,<string pDatabaseName>,<string pUserID>,<string pPassword>,<string pServerType>,<string pConnectionString>)
LogOffServer            procedure(string pDllName,string pServerName,<string pDatabaseName>,<string pUserID>,<string pPassword>)
OpenReport              procedure(string ReportName),*RDCReport
NewReport               procedure(),*RDCReport
SetLicenseKeycode       procedure(string pKeycode)
 end

! common child report object
ChildRDCReportObject class,type,module('RDC.CLW'),DLL(_RDCDLLMode_)
OleControl              ushort    ! ole control
Window                  &Window   ! ole window
Parent                  &cstring  ! parent object
Name                    cstring(100) ! object name
Command                 cstring(2000) ! current command string
Object                  cstring(20)
Init                    procedure(*cstring ParentObject,string ObjectName,ushort OleControl,Window Window),virtual
Kill                    procedure,virtual
 end

Database class(ChildRDCReportObject),type,module('RDC.CLW'),DLL(_RDCDLLMode_)
Tables                  &DatabaseTables
! RDC methods
ConvertDatabaseDriver   procedure(string pDLLName,byte blDoImmediateConvert)  !Use ConvertDatabaseDriver to convert the database driver DLL used by the report.
LogOffServer            procedure(string pDllName,string pServerName,<string pDatabaseName>,<string pUserID>,<string pPassword>)
LogOnServer             procedure(string pDllName,string pServerName,<string pDatabaseName>,<string pUserID>,<string pPassword>)
LogOnServerEx           procedure(string pDllName,string pServerName,<string pDatabaseName>,<string pUserID>,<string pPassword>,<string pServerType>,<string pConnectionString>)
Verify                  procedure,byte
SetLogonInfo            procedure(string pServerName,<string pDatabaseName>,<string pUserID>,<string pPassword>)
! wrapper methods
Init                    procedure(*cstring ParentObject,string ObjectName,ushort OleControl,Window Window),virtual
Kill                    procedure,virtual
 end

ExportOptions class(ChildRDCReportObject),type,module('RDC.CLW'),DLL(_RDCDLLMode_)
! RDC properties
ApplicationFileName     cstring(255)!Gets or sets the destination application file name. Read/Write
CharFieldDelimiter      cstring(2) ! Gets or sets the character used to separate fields in character separated text formats. This character delimits every field in the file.
CharStringDelimiter     cstring(2) ! Gets or sets the character used to separate strings in character separated text formats. This character delimits only string fields (numeric, date fields, etc., have no delimiter).
DestinationType         byte ! as CRExportDestinationType
DiskFileName            cstring(255) ! Gets or sets the file name if the report is exported to a disk.
! When exporting to HTML use HTMLFileName. When exporting to XML use XMLFileName. Read/Write
ExcelAreaGroupNumber    short !Gets or sets the base area group number if the area type is group area when exporting to Excel.
ExcelConstantColumnWidth real !Gets or sets the column width when exporting to Excel.
ExcelTabHasColumnHeadings byte ! Gets or sets exporting to Excel has column headings option.
ExcelUseConstantColumnWidth byte ! Gets or sets export to Excel to use constant column width.
ExcelUseTabularFormat   byte !Gets or sets exporting to Excel to use tabular format.
ExcelUseWorksheetFunctions byte ! Gets or sets export to Excel to use worksheet functions to represent subtotal fields in the report.
ExchangeDestinationType byte ! as CRExchangeDestinationType. Gets or sets the Exchange destination type for reports exported to Exchange folders
ExchangeFolderPath      cstring(255) ! Gets or sets the path of the Exchange folder for reports exported to Exchange (for example, "MyFolders@Inbox").
ExchangePassword        cstring(50) ! Sets Exchange password. Write only
ExchangeProfile         cstring(255) ! Gets or sets a user profile for accessing an Exchange folder for reports exported to Exchange.
!ExchangePathHasColumnHeadings byte !Gets or sets the column heading option when exporting to Exchange. Read/Write
FormatType              byte ! as CRExportFormatType. Gets or sets the format type for the exported report (for example, text, Excel, etc.).
HTMLEnableSeparatedPages byte ! Gets or sets the option to create seperated pages when exporting to HTML format.
HTMLFileName            cstring(255)!Gets or sets the HTML file name for reports exported to HTML format. Read/Write
HTMLHasPageNavigator    byte ! Gets or sets the option to display a page navigator on each page of a report exported to HTML format.Read/Write
LotusDominoComments     cstring(1000) !Gets or sets the destination Lotus Domino comments. Read/Write
LotusDominoDatabaseName cstring(255) !Gets or sets the destination Lotus Domino database name. Read/Wrie
LotusDominoFormName      cstring(255) ! Gets or sets the destination Lotus Domino form name. Read/Write
MailBccList             cstring(255) !Gets or sets a Blind Carbon Copy (BCC) list for reports e-mailed to a VIM e-mail account. Read/Write
MailCcList              cstring(255) !Gets or sets a Carbon Copy (CC) list for reports e-mailed. Read/Write
MailMessage             cstring(4000) ! Gets or sets the e-mail message included with e-mailed reports. Read/Write
MailSubject             cstring(255) ! Gets or sets the e-mail subject heading for reports being e-mailed. Read/Write
MailToList              cstring(255)  ! Gets or sets the To list for reports being e-mailed.
NumberOfLinesPerPage    long ! Gets or sets the number of lines to appear per page option for reports exported to a paginated text format. Read/Write
ODBCDataSourceName      cstring(255) ! Gets or sets the ODBC data source for reports exported to ODBC
ODBCDataSourcePassword  cstring(50) ! Sets the ODBC data source password. Write only
ODBCDataSourceUserID    cstring(50) ! Gets or sets the user name used to access an ODBC data source for reports exported to ODBC. Read/Write
ODBCExportTableName     cstring(255) ! Gets or sets the database table in the ODBC data source that the report file exported to ODBC will be appended to. You can also create a new table using this property. Read/Write
PDFExportAllPages       byte ! Gets or sets wether or not to export all pages of the report to Portable Document Format(PDF). PDFExportAllPages must be set to false when setting PDFFirstPageNumber and PDFLastPageNumber.
PDFFirstPageNumber      long ! Gets or sets the start page, of a page export range, when exporting to PDF. PDFExportAllPages must be set to False or this value is ignored. Read/Wr
PDFLastPageNumber       Long ! Gets or sets the end page, of a page export range, when exporting to PDF. PDFExportAllPages must be set to False or this value is ignored.
RTFExportAllPages       byte !  Boolean. Gets or sets wether or not to export all pages of the report to Rich Text Format(RTF). RTFExportAllPages must be set to false when setting RTFFirstPageNumber and RTFLastPageNumber. Read/Write
RTFFirstPageNumber      long ! Gets or sets the start page, of a page export range, when exporting to RTF. RTFExportAllPages must be set to False or this value is ignored.
RTFLastPageNumber      long ! Gets or sets the end page, of a page export range, when exporting to RTF. RTFExportAllPages must be set to False or this value is ignored.
UseReportDateFormat     byte ! Gets or sets whether the date format used in the report should also be used in the exported report. Can be used for Data Interchange Format (DIF), Record Style Format, and comma, tab, or character separated format.
UseReportNumberFormat   byte ! Gets or sets whether the number format used in the report should also be used in the exported report. Can be used for Data Interchange Format (DIF), Record Style Format, and comma, tab, or character separated format.
XMLAllowMultipleFiles   byte ! Gets or sets allow multiple files, when exporting to XML. When set to True the Schema file for the report will be exported along with the XML file. The Schema file will be either an XML schema (.xsd) or a Document Type Definition (.dtd), depending on the options selected in the XML Forma dilaog box.
XMLFileName             cstring(255) !Gets or sets the file name if the report is exported to a disk.
! RDC methods

PromptForExportOptions  procedure() ! prompts the user for export information using default Crystal Report Engine dialog boxes.
Reset                   procedure
! wrapper methods
GetProperties           procedure
UpdateProperties        procedure

 end

PrintingStatus  Class,TYPE,MODULE('RDC.CLW'),DLL(_RDCDLLMode_)
NumberOfPages          long
NumberOfRecordPrinted  long
NumberOfRecordRead     long
NumberOfRecordSelected long
Progress               byte ! CrPrintingProgress
 end

RDCReport Class,TYPE,MODULE('RDC.CLW'),DLL(_RDCDLLMode_)
! Wrapper properties
RPTObj                  cstring(20)
RPTName                 cstring(255)
!PreviewOLE  ushort
!PreviewObject cstring(20)
!PreviewWindow &Window
Command                 cstring(500)
CRDesigner              &CRDesigner
CRViewer                &CRViewer
RDCApp                  &RDCApplication
PrintingStatus          &PrintingStatus

! RDC properties
SubReports              &SubReports
BottomMargin            long ! the page bottom margin, in twips
CanPerformGroupingOnServer byte ! Gets whether the report can perform grouping on the server. Read only
CaseInsensitiveSQLData  byte ! Gets or sets the report option that indicates whether the SQL data used in the report becomes case sensitive. Read/Write
ConvertDateTimeType     byte ! CRConvertDateTimeType  the report option that specifies the format to be converted for date/time fields.
ConvertNullFieldToDefault byte !Gets or sets the report option that indicates whether to convert any null values to the database field default. Read/Write
Database                &Database ! reference to the database object
DisplayProgressDialog   byte ! Enable or disable the progress dialog. Read/Write  Can be written only when formatting idle.
EnableAsyncQuery        byte ! Gets or sets the enable AsyncQuery  Read/Write
EnableGeneratingDataForHiddenObject byte ! Gets or sets the Enable Generating Data For Hidden Object option. Read/Write
EnableParameterPrompting byte ! Gets or sets the prompting for parameter fields option. Read/Write
EnablePerformQueriesAsynchronously byte ! Gets or sets the perform queries asynchronously option  Read/Write
ExportOptions           &ExportOptions ! refrence to the exportoptions object
FieldMappingType        byte !CRFieldMappingType. Gets or sets the field mapping type. Read/Write
FormulaFields           &FormulaFieldDefinitions ! reference to the FormulaFieldDefinitions object
FormulaSyntax           byte ! CRFormulaSyntax. Gets or sets report formula syntax. Read/Write
GroupNameFields         &GroupNameFieldDefinitions ! reference to the GroupNameFieldDefinitions object
GroupSelectionFormula   cstring(1000) !Gets or sets the group selection formula. Read/Write
GroupSortFields         &SortFields ! reference to the SortFields object
KeywordsInReport        cstring(1000) ! Gets or sets the keywords in the report. Read/Write
Kind                    byte ! CRReportKind. Gets what kind of report. Read only
LeftMargin              long !Gets or sets the page left margin, in twips. Read/Write
MorePrintEngineErrorMessages byte ! Gets or sets the report option that indicates whether to pop up database error dialogs during printing when a Report Engine error occurs.Read/Write
NumberOfGroup           Long ! Gets the number of groups in the report. Read only
PaperOrientation        byte ! CRPaperOrientation. Gets or sets the current printer paper orientation. For the default printer, crDefaultPaperOrientation is returned. Read/Write
PaperSize               byte ! CRPaperSize. Gets or sets the current printer paper size. For the default printer, crDefaultPaperSize is returned.  Read/Write
PaperSource             byte ! CRPaperSource. Gets or sets the current printer paper source. Read/Write
ParameterFields         &ParameterFieldDefinitions ! Gets reference to the collection of all the ParameterFieldDefinitions defined in the report. This property will return parameter fields found in the main report as well as any subreports included in the report (for example, if the main report has 3 parameters and a subreport included within the report has an additional 2 parameters, the number of parameter fields in the collection returned by Report.ParameterFields would be 5).
PerformGroupingOnServer byte ! Gets or sets the performing grouping on server option. Read/Write
PortName                cstring(100) !Gets the printer port name used by the current report. Gets an empty string if the default printer is used. Read only
PrintDate               Date ! Gets or sets the print date for the report. By default, the current date will be used. Read/Write
PrinterDuplex           byte ! CRPrinterDuplexType. Gets or sets the current printer duplex option. Read/Write
PrinterName             cstring(100) ! Gets the printer name used by the report. Gets an empty string if the default printer is used. Read only
DriverName              cstring(100) ! Gets the printer driver name used by the current report. Gets an empty string if default printer is used. Read only
RecordSelectionFormula  cstring(1000) !Gets or sets record selection formula. Read/Write
RecordSortFields        &SortFields ! reference to the SortFields object
ReportAuthor            cstring(1000) !Gets or sets the report author. Read/Write
ReportComments          cstring(1000) !Gets or sets report comments. Read/Write
ReportSubject           cstring(500) !Gets or sets the report subject. Read/Write
ReportTemplate          cstring(500) ! Gets or sets the report template. Read/Write
ReportTitle             cstring(500) ! Gets or sets the report title. Read/Write
RightMargin             long !Gets or sets the page right margin, in twips. Read/Write
RunningTotalFields      &RunningTotalFieldDefinitions !
SavePreviewPicture      byte ! Gets or sets save preview picture with report option.Read/Write
SQLExpressionFields     &SQLExpressionFieldDefinitions ! reference to the SQLExpressionFieldDefinitions collection
SQLQueryString          cstring(4000) !Gets or sets SQL query string.  Read/Write
SummaryFields           &SummaryFieldDefinitions ! SummaryFieldDefinitions Collection
TopMargin               Long ! Gets or sets the page top margin, in twips.
UseIndexForSpeed        byte ! Gets or sets the use index for speed during record selection report option. Read/Write
VerifyOnEveryPrint      byte ! Gets or sets the report option that indicates whether to verify the database every time the report is printed. Read/Write


! RDC methods
AddReportVariable       PROCEDURE(byte type,string pName) ! type As CRReportVariableValueType
CancelPrinting          PROCEDURE
Export                  PROCEDURE(byte promptUser=0)
GetReportVariableValue  PROCEDURE (string pName),string
OpenSubreport           PROCEDURE(String pSubreportName),*RDCReport
OpenSubreport           PROCEDURE(),*RDCReport
PrinterSetup            PROCEDURE(long hWnd = 0)
PrintOut                PROCEDURE(<byte promptUser>,<short numberOfCopy>,<byte collated>,<short startPageN>,<short stopPageN>)
SaveAs                  PROCEDURE(string pFilePath,short fileFormat) ! fileFormat As CRReportFileFormat
SelectPrinter           PROCEDURE(string pDriverName,string pPrinterName,string pPortName)
SetReportVariableValue  PROCEDURE(string pName,any var)

! Wrapper methods
Init                    PROCEDURE(*RDCApplication RDCApp,*cstring RptObj)
Kill                    PROCEDURE
Previewreport           PROCEDURE(short xpos,short ypos,short width,short height,ushort ParentPreviewControl=0,<string CreateString>)
DesignReport            PROCEDURE(short xpos,short ypos,short width,short height,ushort ParentDesignControl=0,<string CreateString>)
PreviewReportClose      PROCEDURE
DesignReportClose       PROCEDURE
GetProperties           PROCEDURE,proc
GetPrintingStatus       PROCEDURE,proc
UpdateProperties        PROCEDURE,proc
DisplayReportWizard     PROCEDURE
ClaDateTime2RDC         procedure(long claDate,long claTime),string
 end

CRViewer class,type,module('RDC.CLW'),DLL(_RDCDLLMode_)
! wrapper properties
OleControl              ushort
Window                  &Window
RptObj                  cstring(20)
ViewerObject            cstring(20)
! RDC properties
DisplayBackgroundEdge   byte(1) ! Gets or sets whether the report is offset from the edge of its view window.
DisplayBorder           byte(1)  ! Gets or sets whether the border of the viewer object is displayed.
DisplayGroupTree        byte(1)  !
DisplayTabs             byte(1)  ! Gets or sets whether the viewer has tabs for navigation between views.
DisplayToolbar          byte(1)  ! Gets or sets the visibility of the toolbar.
EnableAnimationCtrl     byte(1)  ! Gets or sets whether or not the animation control is visible.
EnableCloseButton       byte(1)  ! Gets or sets the visibility of the close button.
EnableDrillDown         byte(1)  ! Gets or sets whether drill down is allowed.
EnableExportButton      byte(1)  ! Gets or sets the visibility of the Export toolbar button.
EnableGroupTree         byte(1)  !Gets or sets whether or not the group tree is available.
EnableHelpButton        byte(1)  ! Gets or sets whether or not the help button appears on the toolbar.
EnableNavigationControls    byte(1) ! Gets or sets whether or not the First Page button, Previous Page button, Next Page button, and Last Page button appear on the toolbar.
EnablePopupMenu         byte(1) ! Gets or sets whether the popup menu is available.
EnablePrintButton       byte(1) ! Gets or sets the visibility of the Print button.
EnableProgressControl   byte(1) ! Gets or sets the visibility of the progress control.
EnableRefreshButton     byte(1)! Gets or sets the visibility of the Refresh button.
EnableSearchControl     byte(1) ! Gets or sets the visibility of the search control.
EnableSearchExpertButton    byte(1)
EnableStopButton        byte(1)
EnableToolbar           byte(1)
EnableZoomControl       byte(1)
! RDC methods
Zoom                    procedure(long ZoomLevel)
Refresh                 procedure()

! wrapper methods
Construct               PROCEDURE
Init                    procedure(ushort ParentDesignControl=0,<string CreateString>),virtual
Kill                    procedure
ResizeWindow            PROCEDURE(short xpos,short ypos,short width,short height)
PreviewReportOpen       procedure(*cstring RptObj)
PreviewReportClose      procedure
GetProperties           procedure
UpdateProperties        procedure
 end

CRDesigner              class,type,module('RDC.CLW'),DLL(_RDCDLLMode_)
! wrapper properties
OleControl              ushort
Window                  &Window
RptObj                  cstring(20)
DesignObject            cstring(32)
! RDC properties
DisplayFieldView        byte ! Gets or sets whether or not the field view is available. The field view is the list of available fields for the report, including Database, Formula, Parameter, Group Name, Running Total, Special, and Unbound fields.
DisplayGrid             byte ! Gets or sets whether or not the grid is displayed.
DisplayHiddenSections   byte ! Gets or sets whether or not a section is available when hidden.
DisplayRulers           byte !Gets or sets whether or not the Ruler is available.
DisplayToolbar          byte !Gets or sets the visibility of the tool-bar.
EnableHelp              byte !Gets or sets the availability of the help options. When True, the Help icon on the toolbar is enabled and the Help command is visible in the shortcut menu. When False, the Help Icon on the toolbar is disabled and the Help command is hidden in the shortcut menu.
EnableSnapToGrid        byte ! Specifies whether or not to automatically align any fields you insert or to resize to the nearest grid coordinate.
GridSize                real ! Gets or sets the size of the grid in inches. Default value is 0.083.
! wrapper methods
Init                    procedure(ushort ParentDesignControl=0,<string CreateString>),virtual
Kill                    procedure,proc
ResizeWindow            PROCEDURE(short xpos,short ypos,short width,short height)
DesignReportOpen        procedure(*cstring RptObj)
DesignReportClose       procedure()
GetProperties           procedure,proc
UpdateProperties        procedure,proc
 end

